/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the SubProduct class.
 * @constructor
 */
function SubProduct() { }

/**
 * Validate the payload against the SubProduct schema
 *
 * @param {JSON} payload
 *
 */
SubProduct.prototype.validate = function (payload) {
  if (!payload) {
    throw new Error('SubProduct cannot be null.');
  }
  if (payload['id'] !== null && payload['id'] !== undefined && typeof payload['id'].valueOf() !== 'string') {
    throw new Error('payload[\'id\'] must be of type string.');
  }

  if (payload['properties']) {
    models['SubProductProperties'].validate(payload['properties']);
  }
};

/**
 * Deserialize the instance to SubProduct schema
 *
 * @param {JSON} instance
 *
 */
SubProduct.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance.properties !== null && instance.properties !== undefined) {
      instance.properties = models['SubProductProperties'].deserialize(instance.properties);
    }
  }
  return instance;
};

module.exports = new SubProduct();
