/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the DatetimeWrapper class.
 * @constructor
 */
function DatetimeWrapper() { }

/**
 * Validate the payload against the DatetimeWrapper schema
 *
 * @param {JSON} payload
 *
 */
DatetimeWrapper.prototype.validate = function (payload) {
  if (!payload) {
    throw new Error('DatetimeWrapper cannot be null.');
  }
  if (payload['field'] && !(payload['field'] instanceof Date || 
      (typeof payload['field'].valueOf() === 'string' && !isNaN(Date.parse(payload['field']))))) {
    throw new Error('payload[\'field\'] must be of type date.');
  }

  if (payload['now'] && !(payload['now'] instanceof Date || 
      (typeof payload['now'].valueOf() === 'string' && !isNaN(Date.parse(payload['now']))))) {
    throw new Error('payload[\'now\'] must be of type date.');
  }
};

/**
 * Deserialize the instance to DatetimeWrapper schema
 *
 * @param {JSON} instance
 *
 */
DatetimeWrapper.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance.field !== null && instance.field !== undefined) {
      instance.field = new Date(instance.field);
    }

    if (instance.now !== null && instance.now !== undefined) {
      instance.now = new Date(instance.now);
    }
  }
  return instance;
};

module.exports = new DatetimeWrapper();
