/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Salmon class.
 * @constructor
 */
function Salmon() { }

/**
 * Validate the payload against the Salmon schema
 *
 * @param {JSON} payload
 *
 */
Salmon.prototype.validate = function (payload) {
  if (!payload) {
    throw new Error('Salmon cannot be null.');
  }
  if (payload['species'] !== null && payload['species'] !== undefined && typeof payload['species'].valueOf() !== 'string') {
    throw new Error('payload[\'species\'] must be of type string.');
  }

  if (payload['length'] === null || payload['length'] === undefined || typeof payload['length'] !== 'number') {
    throw new Error('payload[\'length\'] cannot be null or undefined and it must be of type number.');
  }

  if (util.isArray(payload['siblings'])) {
    for (var i = 0; i < payload['siblings'].length; i++) {
      if (payload['siblings'][i]) {
        if(payload['siblings'][i]['dtype'] !== null && payload['siblings'][i]['dtype'] !== undefined && models.discriminators[payload['siblings'][i]['dtype']]) {
          models.discriminators[payload['siblings'][i]['dtype']].validate(payload['siblings'][i]);
        } else {
          throw new Error('No discriminator field "dtype" was found in parameter "payload[\'siblings\'][i]".');
        }
      }
    }
  }

  if (payload['location'] !== null && payload['location'] !== undefined && typeof payload['location'].valueOf() !== 'string') {
    throw new Error('payload[\'location\'] must be of type string.');
  }

  if (payload['iswild'] !== null && payload['iswild'] !== undefined && typeof payload['iswild'] !== 'boolean') {
    throw new Error('payload[\'iswild\'] must be of type boolean.');
  }
};

/**
 * Deserialize the instance to Salmon schema
 *
 * @param {JSON} instance
 *
 */
Salmon.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance.siblings !== null && instance.siblings !== undefined) {
      var deserializedArray = [];
      instance.siblings.forEach(function(element) {
        if (element !== null && element !== undefined) {
          if(element['dtype'] !== null && element['dtype'] !== undefined && models.discriminators[element['dtype']]) {
            element = models.discriminators[element['dtype']].deserialize(element);
          } else {
            throw new Error('No discriminator field "dtype" was found in parameter "element".');
          }
        }
        deserializedArray.push(element);
      });
      instance.siblings = deserializedArray;
    }
  }
  return instance;
};

module.exports = new Salmon();
